package subject

import "fmt"

func getSupplierValue(val string) string {
	return fmt.Sprintf("%s.%s", prefixes.Supplier, val)
}

var Supplier = struct {
	GetListSupplierInfo             string
	GetDetailSupplierInfo           string
	GetSupplierContractBySupplierID string
	FindAll                         string
	GetListWarehouseFreeShip        string
	CreateCashflow                  string
	DeleteCashflow                  string
	UpdateBalance                   string
	GetCurrentBalance               string
	GetFreeShipInfo                 string
	FindAllOld                      string
	Count                           string
}{
	GetListSupplierInfo:             getSupplierValue("get_list_supplier_info"),
	GetDetailSupplierInfo:           getSupplierValue("get_detail_supplier_info"),
	GetSupplierContractBySupplierID: getSupplierValue("get_supplier_contract_by_supplier_id"),
	FindAll:                         getSupplierValue("find_all"),
	GetListWarehouseFreeShip:        getSupplierValue("get_list_warehouse_free_ship"),
	CreateCashflow:                  getSupplierValue("create_cashflow"),
	DeleteCashflow:                  getSupplierValue("delete_cashflow"),
	UpdateBalance:                   getSupplierValue("update_balance"),
	GetCurrentBalance:               getSupplierValue("get_current_balance"),
	GetFreeShipInfo:                 getSupplierValue("get_free_ship_info"),
	FindAllOld:                      getSupplierValue("find_all_old"),
	Count:                           getSupplierValue("count"),
}
